/**
 * $Id: aess_eventhandlerdrv.h,v 1.0 2009/03/16 11:00:07 wchen Exp $
 *
 *<center>
 *               Avocent Corporation. Proprietary Information.
 * \n<em>
 *      This software is supplied under the terms of a license agreement or
 *      nondisclosure agreement with Avocent Corporation, or its subsidiary, and
 *      may not be copied, disseminated, or distributed except in accordance
 *      with the terms of that agreement.
 *
 *      2001 Gateway Place, Suite 520W, San Jose, California, 95110 U.S.A.
 *\n
 *                  US phone: 408.436.6333
 *
 *        Copyright &copy; 2008 Avocent Corporation.
 *</em> </center>
 *----------------------------------------------------------------------------\n
 *  MODULES     linux driver
 *----------------------------------------------------------------------------\n
 *  @file   aess_eventhandlerdrv.h
 *  @brief  This is the kernel-layer event handler
 *
 *  @internal
 *  $RCSfile: aess_eventhandlerdrv.h,v $
 *  $Revision: 1.0 $
 *  $Date: 2009/03/16 10:16:00 $
 *  $Author: waynechen $
 *  $Source: http://tpe-subversion/AESSTPE/puti/puti_fw/ProjectBase/trunk/platform/wpcm450/evb/src/drivers/eventhandler/eventhandler_driver $
 *  $Name:  $
 *----------------------------------------------------------------------------*/
/*
 * WPCM450 event handler driver.
 *
 * Copyright (C) 2009 Avocent Corp.
 *
 * This file is subject to the terms and conditions of the GNU
 * General Public License. This program is distributed in the hope
 * that it will be useful, but WITHOUT ANY WARRANTY; without even
 * the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 */
#ifndef AESSEVENTHANDLER_H
#define AESSEVENTHANDLER_H

#define EVENTHANDLER_DRIVER_NAME "aess_eventhandlerdrv"
#define INIT_OK 1
#define INIT_FAIL 0

/******************************************************************************
*   STRUCT      :   sEventData
******************************************************************************/
/**
 *  @brief   Structure to event handler driver related data parameter.
 *
 *****************************************************************************/
typedef struct
{
	/** Driver ID */
	UINT16 u16DriverID;		
	
	/** Event command ID */
	UINT32 u32EventID;     
	
} sEventData;

/* kernel driver internal use */
#ifdef AESSEVENTHANDLER_C 

#define MAX_EVENT_NUMBER        0x10


/******************************************************************************
*   STRUCT      :   Function Prototype 
******************************************************************************/
/**
 *  @brief   Prototype for each private function.
 *
 *****************************************************************************/
int aess_generate_driver_event(
								  /* Driver ID, issue by the the event \n
									 handler API in user space */
								  UINT16 u16DriverID, 
								  
								  /* Event ID, defined by each event group */
								  UINT32 u32EventID
							  );

#else
extern int aess_generate_driver_event(
									  /* Driver ID, issue by the the event \n
										 handler API in user space */
									  UINT16 u16DriverID, 
								  
									  /* Event ID, defined by each  \n
										 event group */
									  UINT32 u32EventID
									 );


#endif   /* AESSEVENTHANDLER_C */

#endif   /* AESSEVENTHANDLER_H */

/* End of code */
