/*
 *  linux/arch/arm/mach-ast2000/mm.c
 *
 *  Copyright (C) 1999,2000 Arm Limited
 *  Copyright (C) 2000 Deep Blue Solutions Ltd
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <linux/sched.h>
#include <linux/mm.h>
#include <linux/init.h>

#include <asm/hardware.h>
#include <asm/io.h>
#include <asm/pgtable.h>
#include <asm/page.h>
 
#include <asm/mach/map.h>

static struct map_desc ast2000_io_desc[] __initdata = 
{

 { IO_ADDRESS(ASPEED_VIC_BASE),		__phys_to_pfn(ASPEED_VIC_BASE),        	SZ_4K,		MT_DEVICE},
 { IO_ADDRESS(ASPEED_TIMER_BASE),       __phys_to_pfn(ASPEED_TIMER_BASE),       SZ_4K,          MT_DEVICE},
 { IO_ADDRESS(ASPEED_UART0_BASE),       __phys_to_pfn(ASPEED_UART0_BASE),       SZ_4K,          MT_DEVICE},
 { IO_ADDRESS(ASPEED_UART1_BASE),       __phys_to_pfn(ASPEED_UART1_BASE),       SZ_4K,          MT_DEVICE},
 { IO_ADDRESS(ASPEED_MAC_BASE),       __phys_to_pfn(ASPEED_MAC_BASE),       SZ_4K,          MT_DEVICE},
};

void __init ast2000_map_io(void)
{
	iotable_init(ast2000_io_desc, ARRAY_SIZE(ast2000_io_desc));
}
