/*
 *  linux/arch/arm/mach-ast2000/ast2000.c
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <linux/config.h>
#include <linux/types.h>
#include <linux/sched.h>
#include <linux/interrupt.h>
#include <linux/init.h>

#include <asm/hardware.h>
#include <asm/irq.h>
#include <asm/setup.h>
#include <asm/mach-types.h>

#include <asm/mach/arch.h>
#include <asm/mach/time.h>

extern void aspeed_map_io(void);
extern void aspeed_init_irq(void);
extern struct sys_timer aspeed_timer;

static u64 udc_dma_mask = ~(u32)0;
static struct resource ast2100_udc_resources[] = {
	[0] = {
		.start	= INT_USB20,
		.end	= INT_USB20,
		.flags	= IORESOURCE_IRQ,
	},
};
static struct platform_device udc_device = {
	.name		= "ast2100-udc",
	.id		= -1,
	.resource	= ast2100_udc_resources,
	.num_resources	= ARRAY_SIZE(ast2100_udc_resources),
	.dev		=  {
		.dma_mask	= &udc_dma_mask,
	}
};
static struct platform_device *devices[] __initdata = {
	&udc_device,

};
static void __init aspeed_init(void)
{
    int ret;

    ret = platform_add_devices(devices, ARRAY_SIZE(devices));
    if (0!=ret)
    {
         printk("\n************************\n");
         printk("\nplatform add devices failes\n");		 
         printk("\n************************\n");		 
    }else
    {
         printk("\n************************\n");
         printk("\nplatform add devices successful\n");		 
         printk("\n************************\n");		 

    }
    return;
}

MACHINE_START(AST2100, "ASPEED-AST2100")
	/* MAINTAINER("ASPEED Technology Inc.") */
	.phys_io		= IO_START,
//	.phys_ram		= ASPEED_SDRAM_BASE,     //AVCT: FOR 2.6.18.6 linux kernel
	.io_pg_offst		= (IO_ADDRESS(IO_START)>>18) & 0xfffc,
	.map_io			= aspeed_map_io,
	.timer			= &aspeed_timer,
	.init_irq		= aspeed_init_irq,
	.init_machine		= aspeed_init,
MACHINE_END
