/**
 *
 *               Avocent Corporation. Proprietary Information.
 *      This software is supplied under the terms of a license agreement or
 *      nondisclosure agreement with Avocent Corporation, or one of its affiliates, and
 *      may not be used, copied, disseminated, or distributed except in accordance
 *      with the terms of that agreement.
 *
 *      3541 Gateway Boulevard, Fremont, California, 94538 U.S.A.
 *                  US Phone: 510-771-6100
 *      Copyright 2001-2009 Avocent Corporation. All rights reserved.
 *
 *----------------------------------------------------------------------------
 * MODULES      AESS Serial Driver
 *----------------------------------------------------------------------------
 *  @file   aspeed_serial.h
 *  @brief  header file for aspeed serial driver
 *
 *----------------------------------------------------------------------------*/

#ifndef ASM_ARM_HARDWARE_GUCMVP2000_SERIAL_H
#define ASM_ARM_HARDWARE_GUCMVP2000_SERIAL_H

/* Interrupt Enable Register */
#define UART_IER_EMSI       0x08    /* Enable Modem Status Interrupt */
#define UART_IER_ELSI       0x04    /* Enable Line Status Interrupt */
#define UART_IER_ETEI       0x02    /* Enable Transmit Holding Empty Interrupt */
#define UART_IER_ERDI       0X01    /* Enable Received Data Interrupt */

/* FIFO Control Register */
#define UART_FCR_XMITR      0x04    /* XMIT FIFO Reset */
#define UART_FCR_RCVRR      0x02    /* RCVR FIFO Reset */
#define UART_FCR_FIFOE      0x01    /* FIEO Enable */

/* Line Control Register */
#define UART_LCR_DLAB       0x80    /* Divisor Latch Address Bit */
#define UART_LCR_BRK        0x40    /* Break Control */
#define UART_LCR_EPS        0x10    /* Even Parity Select */
#define UART_LCR_PEN        0x08    /* Parity Enable */
#define UART_LCR_STOP       0x04    /* Stop Bit */
#define UART_LCR_WLEN_MASK  0x03    /* bits per character mask */
#define UART_LCR_WLEN_8     0x03    /* 8 bits per character */
#define UART_LCR_WLEN_7     0x02    /* 7 bits per character */
#define UART_LCR_WLEN_6     0x01    /* 6 bits per character */
#define UART_LCR_WLEN_5     0x00    /* 5 bits per character */

/* Line Status Register */
#define UART_LSR_TEMT       0x40    /* Transmitter Empty */
#define UART_LSR_THRE       0x20    /* Transmitter Holding Register Empty */
#define UART_LSR_BE         0x10    /* Break Error */
#define UART_LSR_FE         0x08    /* Framing Error */
#define UART_LSR_PE         0x04    /* Parity Error */
#define UART_LSR_OE         0x02    /* Overrun Error */
#define UART_LSR_DR         0x01    /* Data Ready */
#define UART_LSR_ANY        (UART_LSR_BE|UART_LSR_FE|UART_LSR_PE|UART_LSR_OE)

#endif

/* End of code */

